{%- from "nova/map.jinja" import client with context %}
{%- if client.enabled %}

{%- for identity_name, identity in client.get('resources', {}).get('v21', {}).iteritems() %}

  {%- if identity.flavor is defined %}
  {%- for flavor_name, flavor in identity.flavor.iteritems() %}

novav21_openstack_flavor_{{ flavor_name }}:
  novav21.flavor_present:
    - name: {{ flavor_name }}
    - cloud_name: {{ identity_name }}
    {%- if flavor.flavor_id is defined %}
    - flavor_id: {{ flavor.flavor_id }}
    {%- endif %}
    {%- if flavor.ram is defined %}
    - ram: {{ flavor.ram }}
    {%- endif %}
    {%- if flavor.disk is defined %}
    - disk: {{ flavor.disk }}
    {%- endif %}
    {%- if flavor.vcpus is defined %}
    - vcpus: {{ flavor.vcpus }}
    {%- endif %}
    {%- if flavor.extra_specs is defined %}
    - extra_specs: {{ flavor.extra_specs }}
    {%- endif %}

  {%- endfor %}
  {%- endif %}

  {%- if identity.keypair is defined %}
  {%- for keypair_name, keypair in identity.keypair.iteritems() %}
nova_keypair_{{ keypair_name }}:
  novav21.keypair_present:
    - name: {{ keypair_name }}
    {%- if keypair.pub_file is defined %}
    - public_key_file: {{ keypair.pub_file }}
    {%- endif %}
    {%- if keypair.pub_key is defined %}
    - public_key: {{ keypair.pub_key }}
    {%- endif %}
    - cloud_name: {{ identity_name }}

  {%- endfor %}
  {%- endif %}

  {%- if identity.aggregates is defined %}
  {%- for aggregate_name, aggregate in identity.aggregates.iteritems() %}
nova_aggregate_{{ aggregate_name }}:
  novav21.aggregate_present:
    - name: {{ aggregate_name }}
    {%- if aggregate.availability_zone is defined %}
    - availability_zone_name: {{ aggregate.availability_zone }}
    {%- endif %}
    {%- if aggregate.hosts is defined %}
    - hosts: {{ aggregate.hosts }}
    {%- endif %}
    {%- if aggregate.metadata is defined %}
    - metadata: {{ aggregate.metadata }}
    {%- endif %}
    - cloud_name: {{ identity_name }}
  {%- endfor %}
  {%- endif %}

{%- endfor %}
{%- endif %}
